using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Diagnostics;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using System.IO;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class Startup
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Configuration

        /// <summary>
        /// 
        /// </summary>
        public IConfiguration Configuration { get; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Startup(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ÷ ϱ - ConfigureServices(services)

        /// <summary>
        ///  ÷ ϱ
        /// </summary>
        /// <param name="services"> ÷</param>
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddRazorPages();
        }

        #endregion
        #region ϱ - Configure(app, environment)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="app">ø̼ </param>
        /// <param name="environment"> ȣƮ ȯ</param>
        public void Configure(IApplicationBuilder app, IWebHostEnvironment environment)
        {
            if(environment.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseExceptionHandler
                (
                    builder =>
                    {
                        builder.Run
                        (
                            async context =>
                            {
                                context.Response.StatusCode  = 500;
                                context.Response.ContentType = "text/html";

                                await context.Response.WriteAsync("<html lang=\"en\"><body>\r\n");
                                await context.Response.WriteAsync("ERROR!<br><br>\r\n");

                                IExceptionHandlerPathFeature feature = context.Features.Get<IExceptionHandlerPathFeature>();

                                if(feature?.Error is FileNotFoundException)
                                {
                                    await context.Response.WriteAsync("File error thrown!<br><br>\r\n");
                                }
                                else
                                {
                                    await context.Response.WriteAsync("Error thrown!<br><br>\r\n");
                                }

                                await context.Response.WriteAsync("<a href=\"/\">Home</a><br>\r\n");
                                await context.Response.WriteAsync("</body></html>\r\n");
                                await context.Response.WriteAsync(new string(' ', 512)); // IE Padding
                            }
                        );
                    }
                );

                app.UseHsts();
            }

            app.UseHttpsRedirection();

            app.UseStaticFiles();

            app.UseRouting();

            app.UseAuthorization();

            app.UseEndpoints
            (
                endpoints =>
                {
                    endpoints.MapRazorPages();
                }
            );
        }

        #endregion
    }
}